%ext ck4
%maphead maphead.ck4				#New levels
%egahead EGAHEAD.CK4				#New graphics
%patchfile $20DF0 AUDIOHED.CK4			#Patch the Audiohead [652bytes]
%patchfile $249C2 Keen4.tli			#New tile properties


#########################
#Eliminate Game stuff	#
#########################

#Skip initialization screen (Frees $19AAA-$19FE9)
%patch $38AD $90 $90 $90 $90 $90 #Don't load B800
%patch $38D0 $90 $90 $90 $90 $90 #Don't display game info, 'Loading...' text
%patch $39B2 $90 $90 $90 $90 $90 #Don't wait for key, show 'Ready' text

#Ending Sequence music (Menu theme)
%patch $9CD7 $0004W

#Ending sequence doesn't wait for keypresses for pages 1-8 and 13-onwards
%patch $9D03 $FF $06 $7A1EW  $83 $3E $7A1EW  $0C $77 $5D $83 $3E $7A1EW  $08
             $72 $56 $9A $14600F43RL     $0B $C0 $75 $4D $EB $F5

#Play music in help over dart behavior code
%patch $98F4  $9A $11A20EE6RL     $EB $11
%patch $12906 $55 $8B $EC $56 $57 $8B $76 $06 $B8 $0004W  $50 $B8 $00C8W  $50
              $B8 $0140W  $50 $33 $C0 $50 $50 $9A $1D060DE3RL     $83 $C4 $0A
              $B8 $0004W  $50 $9A $06BD20C7RL     $83 $C4 $02 $5F $5E $5D $CB

#Play music in the menu
%patch $1CC6F $06BD20C7RL
%patch $1CC6B $0001W      #Play this level's song

#No thumbs up when entering levels
%patch $642A $CB

#Never display then ending B800 screen
%patch $3AA2 $EB

#Remove compression
%patch $12D2C $55 $8B $EC $56 $57 $8C $DA $C4 $7E $0A $C5 $76 $06 $8B $4E $0E $D1
              $E9 $FC $F3 $A5 $73 $01 $A4 $8E $DA $5F $5E  $5D $CB

#Disable status window
%patch $78B2 $EB $30

#Always use WoW scrolling, even in level 0
%patch $904F $EB $19

#Disable EKA
%patch $8AD1 $5D $CB

#Keen 4 -disable F10 cheats
%patch $7ABE $EB

#Limit options menu to just score
%patch $1FAB2 $0000W $0000W $0000W $0000W $0000W $0000W $0000W $0000W $0000W
%patch $33893 "SCOREBOX" $00
%patch $1FCE4 $0003W $0000W $0018W $4A23W

#Keyboard config goes straight to movement menu
%patch $1FCF6 $0003W $0008W $0025W $4891W $0000W $1FB100A2RL

#Disable single demos -Keen 4
%patch $3C47 $90 $90 $90 $90 $90 #Demo 2
%patch $3C5C $90 $90 $90 $90 $90 #Demo 3
%patch $3C6C $90 $90 $90 $90 $90 #Demo 4

#Story palette changed for flag
%patch $2F05E $00 $01 $1F $03 $04 $05 $06 $07     #Dark colors
              $00 $00 $00 $00 $00 $00 $00 $00 $00 #Light colors (and border color)

#Terminator text palette:
%patch $2F078 $00 $04 $04 $1C $1C $04 $04 $04      #Dark colors
              $14 $14 $14 $14 $14 $14 $14 $14 $00 #Light colors (and border color)

#Terminator text palette 2, screen moves out:
%patch $2F088 $00 $04 $04 $04 $04 $04 $04 $04     #Dark colors
              $1C $1C $1C $1C $1C $1C $1C $1C $00 #Light colors (and border color)

#Remove credits bitmaps
%patch $4006 $CB

#Story read from
%patch $5582 $1EE3RW #This * $10
%patch $5587 $0004W  #Plus this

#Story text file
%patchfile $1EE34 "STORY.CK4"

#Level names
%patch $1F040 "The White House?!" $00
%patch $1F1F0 "Mortimer heads" $0A
              "down to his secret" $0A
              "lair" $00

#Level music
%patch $2F206 $0002W $0003W $0004W $0005W $0001W $0002W
%patch $2F22C $0001W #HS


#########################
#Eliminate Keen stuff	#
#########################

#What level(s) Keen uses map tile interaction in -Keen 4
%patch $8FBC $A7EDW $00 $90 $90

#Disable pogo, shooting and jumping
%patch $8B84 $5D $CB

#Disable poles entirely
%patch $B8A0 $33 $C0 $5E $8B $E5 $5D $CB

#Keen cannot grip ledges...
%patch $D5D3 $EB #Left
%patch $D6B9 $EB #Right

#Raindrops convert Mort into Keenshot
%patch $D060 $19
%patch $D183 $B8 $1738W  $50 $56 $9A $09DC120ARL     $83 $C4 $04 $C7 $44 $10
                 $0001W  $C7 $44 $0E $0000W  $C7 $44 $06 $0000W  $EB $7D

#Death type resets clipping, allowing revert smash
%patch $D171 $C7 $44 $06 $0001W  $EB $27

#Mort's shot- turn to Mort on tile collision
%patch $E63A $EB $02 #Keen's shot sprite type doesn't change when it smashes
%patch $E63F $098CW
%patch $305C4 $38

#Flipping switch wins game, changes things (Trolmort anim, timer, HS music)
%patch $6BD9 $0EB2W
%patch $C0B9 $55 $8B $EC $83 $EC $16 $56 $57 $C7 $06 $7A70W  $000DW
             $C7 $06 $0A7CW  $009BW  $C7 $06 $0A7EW  $009BW  $C7 $06
             $0A86W  $4100W  $C7 $06 $03BCW  $0005W  $C7 $06 $3188W
             $009AW  $C7 $06 $318AW  $009AW  $C7 $06 $0398W  $0004W
             $B8 $0015W  $50 $9A $187409F1RL     $83 $C4 $02 $5F $5E $8B $E5 $5D $CB


#########################
#HS Kitten sequence	#
#########################

#Keen goes to shoot sequence instead of bored to in HS
%patch $BC24 $A7EDW $13 $75

#No book reading bored sequence
%patch $BBF5 $49 #Disable Bored-3

#Stop 1 interrupting 2
%patch $2F848 $0B80045CRL
%patch $2F866 $0B80045CRL
%patch $2F884 $0B80045CRL
%patch $2F8A2 $0B80045CRL
%patch $2F8C0 $0B80045CRL
%patch $2F8DE $0B80047ARL #Reset

#Alter 3 behavior to reset variables on arrow press
%patch $BC5C $55 $8B $EC $56 $8B $76 $06 $83 $3E $A7D2W  $08 $74 $0D
             $33 $C0 $89 $44 $40 $89 $44 $3E $C7 $44 $1C $098CW  $5E $5D $CB

#Final loop behavior resets variables too
%patch $BC7A $55 $8B $EC $56 $8B $76 $06 $33 $C0 $89 $44 $40 $89 $44
             $3E $5E $5D $CB

#Mortimer wait-shoot sequence (Hijacked mooning action, plus one extra)
%patch $2F8EC $0096W $0096W
%patch $2F8F6 $005AW
%patch $2F90A $0097W $0097W
%patch $2F914 $005AW
%patch $2F926 $0D6AW #Goto shooting

#Shooting sequence hijacked
%patch $2FBDA $0098W $0098W
%patch $2FBF8 $0098W $0098W
%patch $2FC14 $0AB8W #Goto last mooning action
%patch $2F928 $0097W $0097W $0002W $0000W $0001W $0000W $0000W $0000W
              $00000000L    $00000000L    $0B801AA2RL   $098CW

#Keen's shot spawn action, 2nd frame, clipless
%patch $E614 $56
%patch $E5A1 $0003W
%patch $E5A9 $06 $0000W

#Position shot relative to Mort
%patch $C9B1 $FFC0W #Vertical position
%patch $C9B8 $0300W #Horizontal position

#Kitten explode sequence (3shot, 2smash, consume Keenboreds) =$1756W
%patch $305C6 $00A2W $00A2W $0000W $0000W $0000W $0010W $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $1774W
%patch $305E4 $00A3W $00A3W $0000W $0000W $0000W $0008W $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $1792W
%patch $30602 $00A4W $00A4W $0000W $0000W $0000W $0008W $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $17B0W
%patch $30620 $00A5W $00A5W $0000W $0000W $0000W $0008W $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $17CEW
%patch $3063E $00A6W $00A6W $0000W $0000W $0000W $0008W $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0AD6W
%patch $2F946 $00A7W $00A7W $0000W $0000W $0000W $0008W $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0AF4W
%patch $2F964 $00A8W $00A8W $0000W $0000W $0000W $0008W $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0B12W
%patch $2F982 $00A9W $00A9W $0000W $0000W $0000W $0008W $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0B30W
%patch $2F9A0 $00AAW $00AAW $0000W $0000W $0000W $0008W $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0B4EW
%patch $2F9BE $00ABW $00ABW $0000W $0000W $0000W $0008W $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0B6CW
%patch $2F9DC $00ACW $00ACW $0000W $0000W $0000W $0008W $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0000W


#########################
#Limit sprite spawning	#
#########################

#Shrink the spawn list to Mort, Mart and Platform
%patch $E947 $05

#Rearrange list spawns
%patch $EE85 $0069W #Right Facing Keen (At $E959)
%patch $EE87 $0064W #Left Facing Keen (At $E9854)
%patch $EE89 $00E4W #Mart (Member)
%patch $EE8B $038EW #Kitten
%patch $EE8D $0122W #Lindsey (Warning)

#Keen's spawns rearranged for efficiency
%patch $E954 $B8 $FFFFW  $EB $03
             $B8 $0001W  $50 $FF $76 $FC $57 $9A $0B80000ERL			#Keen's direction is +1
             $83 $C4 $06 $9A $0D8F0003RL     $C7 $06 $CB3DW  $0001W  $B8 $2A3ARW
                 $8A $16 $EC $7A $8E $C0 $26 $08 $16 $00FDW  $83 $3E $A7EDW $00 #Cache scoreboard too
             $75 $1A $83 $3E $3BD6W  $00 $75 $13 $83 $3E $7A72W  $00 $75 $0C $FF
             $76 $FC $57 $9A $0D8F050ARL     $83 $C4 $04 $E9 $0457W

#Ancilliary Keen spawn (MapKeen)
%patch $DDFA  $55 $8B $EC $33 $C0 $50 $9A $06BD1E11RL     $83 $C4 $02 $8B $1E
              $D8 $A7 $C7 $07 $0001W  $C7 $47 $02 $0002W  $C7 $47 $0A $3400W 
              $C7 $47 $0C $4580W  $B8 $1492W  $50 $53 $9A $09DC118CRL     $83
              $C4 $04 $5D $CB


#########################
#Lindsey		#
#########################

#Cache
%patch $306EC $0099W #Lindsey Cache start
%patch $30736 $0099W #Lindsey cache end

#1 action
%patch $32776 $38EAW

#Change sprite and behavior
%patch $3276A $00000000L
%patch $3275A $0099W $0099W

#Change sound
%patch $EFD9 $000EW #Sound played

#Texts read from
%patch $0EFA7 $03BEW #Lindsey says
%patch $30844 $1BB4W #Scuba gear...
%patch $30846 $1BB4W #Pyramid...
%patch $2F22E "No! I must not greet my" $0A
              "adoring public! I must" $0A
              "destroy the Kreeg" $0A
              "menace!" $00

#Change Linds message img
%patch $EF53 $006FW #Cache Lindsey's head
%patch $EF84 $006FW #Display Lindsey's head (at 0,0)

#No Keen's reply window
%patch $EFFA $E9 $00A1W


#########################
#Kitten			#
#########################

#Board react to anything on touch
%patch $31FF8 $0099W $0099W
%patch $32008 $00000000L     $1080114FRL

#Fallboard collision, become flamed Kitten
%patch $1194F $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $B8 $0025W  $50 $9A $187409F1RL
                  $83 $C4 $02 $C7 $44 $1C $0B8AW  $5F $5E $5D $CB

#Flamed Kitten sequence
%patch $2F9FA $0099W $0099W $0000W $0000W $0000W $0010W $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0BA8W
%patch $2FA18 $00CAW $00CAW $0000W $0000W $0000W $000AW $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0BC6W
%patch $2FA36 $00C9W $00C9W $0000W $0000W $0000W $000AW $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0BA8W

#Convert mapKeen to Gaster -minimal patch alters, uses dartgun tcol for tile alts
%patch $30302 $00BDW $00BDW $0002W
%patch $30312 $00000000L    $0FA80C57RL    $11A20CA1RL   $0000W

#Gaster collision, play sound, change action
%patch $106D7 $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $B8 $0004W  $50 $9A $187409F1RL
                  $83 $C4 $02 $C7 $44 $1C $24FEW  $5F $5E $5D $CB

#Gaster vanish sequence (Skpest)
%patch $3136E $00BCW $00BCW 
%patch $31378 $000AW
%patch $3138C $00BBW $00BBW
%patch $31396 $000AW
%patch $313AA $00BAW $00BAW
%patch $313B4 $000AW
%patch $313C8 $00B9W $00B9W
%patch $313D2 $000AW
%patch $313E4 $0000W

#Gastphics offset patch
%patch $212AB $87 $C1 $08 $97 $C4 $08 $A7 $C7 $08 $B7 $CA $08 $C7 $CD $08
%patch $17C8B $B8 $FFFFW $50
%patch $17CBA $B8 $FFFFW $50


#########################
#Death window, restart	#
#########################

#Rectangle left boundary
%patch $6748 $001EW #Topmost
%patch $6767 $001EW #Top
%patch $6788 $001EW #Bottom
%patch $67A9 $001EW #Bottommost
%patch $67B9 $001EW #Side 1
%patch $67D3 $001FW #Side 2

#Rectangle right boundary
%patch $6741 $001EW #Topmost
%patch $6760 $001EW #Top
%patch $6781 $001EW #Bottom
%patch $67A2 $001EW #Bottommost
%patch $67F1 $001EW #Side 3
%patch $680F $001FW #Side 4

#Widen window for text
%patch $6696  $0018W #Window width

#Text
%patch $66F6  $031CW #Text called from
%patch $2F18C "Try Again, Einstein!" $00
%patch $2F17A "even make it past" $00

#Rectangle doesn't move
%patch $670B $EB $04 #From bottom option

#Esc retries level
%patch $6935 $EB $04

#Remove 'Try again'; reset cube counter on death
%patch $66DB $C7 $06 $7A58W $0000W $EB $04

#Only one option in window
%patch $6989 $E9 $FD7FW

#Change default option in window to 'Exit'
%patch $6709 $0001W

#Either selected option retries level
%patch $6971 $5F $5E $8B $E5 $5D $CB

#Game over window
%patch $5CE0  $0018W #Width
%patch $2F0BE "Game Over? How the hell?!" $00


#########################
#Member - Mart		#
#########################

#Change Member anim, 1 action
%patch $30E28 $00E2W $00E2W $0002W $0000W $0001W $0000W $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $1FB8W

#Don't change music when talking to Oracle janitor
%patch $F106 $EB $0A

#Fix Janitor message to always happen
%patch $CD92 $90 $90

#Change last window
%patch $F2E9 $0071W

#Don't show frowning part of Keen frowning bitmap
%patch $F319 $90 $90 $90 $90 $90

#Text calls
%patch $F1B7 $1F5FRW #Text read from 2.1
%patch $F1BB $0009W  #2.2
%patch $F22A $1F51RW #Text read from 3.1
%patch $F29B $1F4BRW #Text read from 4.1

#Text
%patch $1F580 "Mort! Australia's been" $0A
              "reduced to an unlivable" $0A
              "hellscape! A barren" $0A
              "burning ruin! Or..." $0A
              "maybe it's always been" $0A
              "like that." $00
%patch $1F5F9 "I ordered it nuked just" $0A
              "to be sure, but I can't" $0A
              "blast this many aliens" $0A
              "by myself! I hope you" $0A
              "have a plan for this!" $00
%patch $1F510 "Don't worry, I have this" $0A
              "under control. Nuke it" $0A
              "again to be sure, I'll" $0A
              "be done before dinner" $0A
              "I promise." $00
%patch $1F4B0 "Alright. Me and the" $0A
              "kids are going to" $0A
              "Chungella IV for" $0A
              "sandwiches, we'll" $0A
              "meet you there." $00


#########################
#Modify game stuff	#
#########################

#Change default high score names
%patch $33234 "Mortimer McMire" $00
%patch $33274 "Mortimer" $00
%patch $332B4 "Mort" $00
%patch $332F4 "Mr. M" $00
%patch $33334 "Grand Intellect" $00
%patch $33374 "Morty" $00
%patch $333B4 "                 " $00
%patch $333F4 "Billy Blazenowits" $00

#Points: (999'999'999)
%patch $3326E $3B9AC9FFL
%patch $332AE $3B9AC9FFL
%patch $332EE $3B9AC9FFL
%patch $3332E $3B9AC9FFL
%patch $3336E $3B9AC9FFL
%patch $333AE $3B9AC9FFL
%patch $333EE $3B9AC9FFL
%patch $3342E $00000001L #Billy

#Move scores a bit to fit Mort's in
%patch $5A9A $012CW

%end